# bf.js

## What does it do?

bf.js compiles [brainfuck](http://en.wikipedia.org/wiki/Brainfuck) into
javascript meant for running in node.js.  For example,

    node> var bf = require('bf')
    node> bf('++++++++++[>+++++++>++++++++++>+++>+<<<<-]>++.>+.+++++++..+++.>++.<<+++++++++++++++.>.+++.------.--------.>+.>.')
    Hello World!

    node> 

Cool, right?

## Why?

[Tane Piper](http://tanepiper.com/) made a joke about a 
brainfuck module for node.js, and I thought it'd be a quick project--after all,
brainfuck was designed to be easy to compile (though not particularly easy to
write)!

No, I have little interest in Actually Writing Brainfuck. :)

## How do I install it?

You can just copy bf.js if you'd like, or you can use npm:

    npm install .

## What does it require? Why only node.js?

bf.js requires prompt, written by [pkrumins](http://www.github.com/pkrumins) and
I wrote, in order to manage user input in node.js. Managing input, I found, is
by far the most difficult part (arguably, the *only* difficult part) of writing 
a bf -> js compiler.

## Improvements?

Yeah--Right now sequential increments look like this:

            stk.incr();
            stk.incr();
            stk.incr();
            stk.incr();
            stk.incr();
            stk.incr();
            stk.incr();
            stk.incr();
            stk.incr();
            stk.incr();
            while (stk.val()) {
            stk.ptr.incr();
            stk.incr();
            stk.incr();
            stk.incr();
            stk.incr();
            stk.incr();
            stk.incr();
            stk.incr();
            stk.ptr.incr();
            stk.incr();
            stk.incr();
            stk.incr();
            stk.incr();
            stk.incr();
            stk.incr();

It would be nice to collapse these into something like:

    .tap(function() {
        stk.incr(10);
        while (stk.val()) {
        stk.ptr.incr();
        stk.incr(7);
        stk.ptr.incr();
        stk.incr(6);

Moreover, while loops don't have indenting right now--that would also be nice to add, for readability's sake:

    .tap(function() {
        stk.incr(10);
        while (stk.val()) {
            stk.ptr.incr();
            stk.incr(7);
            stk.ptr.incr();
            stk.incr(6);

There are probably a few more optimizations to the output that would be nice.

## Wanna help?

Go for it!  Fork, hack, pull request.  As usual, atomic commits are nice, but
I'm no complainer. :)

## Authors:

* Joshua Holbrook ( <http://jesusabdullah.github.com/> )

## Licensing:

                DO WHAT THE FUCK YOU WANT TO PUBLIC LICENSE
                        Version 2, December 2004

     Copyright (C) 2004 Sam Hocevar <sam@hocevar.net>

     Everyone is permitted to copy and distribute verbatim or modified
     copies of this license document, and changing it is allowed as long
     as the name is changed.

                DO WHAT THE FUCK YOU WANT TO PUBLIC LICENSE
       TERMS AND CONDITIONS FOR COPYING, DISTRIBUTION AND MODIFICATION

      0. You just DO WHAT THE FUCK YOU WANT TO.
