module.exports = function () {
    //Parsing arguments
    var bf = arguments[0];
    var compile = false;
    switch(arguments.length) {
    case 1:
        break;
    case 2:
        if ( typeof(arguments[1]) == 'string' ) {
            compflag(arguments[1]);
        } else if ( typeof(arguments[1]) == 'function' ) {
            var cb = arguments[1];
        } else {
            throw( "Frickin' odd arguments! "
                 + "Usage: bf([bf string],\n"
                 + "['eval'|'compile' (optional, default behavior 'eval')],\n"
                 + "[cb (optional)])" );
        }
        break;
    case 3:
        var cb = arguments[2];
        compflag(arguments[1]);
        break;
    default:
        throw( "Outrageous number of arguments. "
             + "Usage: bf([bf string],\n"
             + "['eval'|'compile' (optional, default 'compile')],\n"
             + "[cb (optional)])" );
        break;
    }

    function compflag(str) {
        if (str == "compile") {
            compile = true;
        } else if (str !== 'eval') {
            throw( "Behavior arg should be either 'eval' or 'compile'." );
        }
    }

    //Writing down "prologue"...
    var js = [];
    js.push( "var sys = require('sys');");
    js.push( "var Prompt = require('prompt');");
    js.push( "");
    js.push( "var stk = new function() {");
    js.push( "    var self = this;");
    js.push( "    self.stk = [0];");
    js.push( "    self.ptr = { \"val\": 0");
    js.push( "               , \"incr\": function () {");
    js.push( "                       this.val++;");
    js.push( "                           if (self.stk[this.val] === undefined) {");
    js.push( "                               self.stk.push(0);");
    js.push( "                           }");
    js.push( "                       }");
    js.push( "               , \"decr\": function () {");
    js.push( "                       if (self.stk[this.val-1] === undefined) {");
    js.push( "                           self.stk = [0].concat(self.stk);");
    js.push( "                       } else {");
    js.push( "                           this.val--;");
    js.push( "                       }");
    js.push( "                   }");
    js.push( "               }");
    js.push( "    self.val = function () {");
    js.push( "        return self.stk[self.ptr.val];");
    js.push( "        }");
    js.push( "    self.incr = function () {");
    js.push( "        self.stk[self.ptr.val]++;");
    js.push( "    }");
    js.push( "    self.decr = function () {");
    js.push( "        self.stk[self.ptr.val]--;");
    js.push( "    }");
    js.push( "    self.chg = function (v) {");
    js.push( "        self.stk[self.ptr.val] = v;");
    js.push( "    }");
    js.push( "}");
    js.push( "");
    js.push( "");
    js.push( "Prompt()");
    js.push( "    .tap(function() {");

    //Actually parsing the brainfuck
    while (bf.length > 0) {
        switch( bf[0] ) {
        case ">":
            js.push( "        stk.ptr.incr();" );
            break;
        case "<":
            js.push( "        stk.ptr.decr();" );
            break;
        case "+":
            js.push( "        stk.incr();" );
            break;
        case "-":
            js.push( "        stk.decr();" );
            break;
        case ".":
            js.push( "        sys.print( String.fromCharCode(stk.val()) );" );
            break;
        case ",":
            if (js[js.length-1] === "    .tap(function() {") {
                js.pop();
            } else {
                js.push( "})\n");
            }
            js.push( "    .ask('> ', 'x')\n"
                   + "    .tap(function(vars) {\n" 
                   + "        stk.chg( vars.x.toString('utf-8')[0].charCodeAt() );");
            break;
        case "[":
            js.push( "        while (stk.val()) {" );
            break;
        case "]":
            js.push( "        }" );
            break;
        default:
            console.log( "WARNING: I don\'t think that\'s valid brainfuck "
                       + "because ihnfi what to do with this character!" );
        }
        bf = bf.slice(1,bf.length);
    }
    js.push('    sys.print("\\n\");');
    js.push('    })\n    .end();');

    //What to do with bf output
    if (cb) {
        if (compile) {
            cb(js.join('\n'));
        } else {
            //Note that eval() doesn't actually RETURN anything.
            //As such, this behavior is ill-defined atm.
            //Perhaps, it should return the state of the stack.
            cb(eval(js.join('\n')));
        }
    } else {
        if (compile) {
            return js.join('\n');
        } else {
            eval(js.join('\n'));
        }
    }
}
